unit unProcessingThread;
//This thread is responsible for synchronizing events into the main thread.

interface
uses Classes,Windows,Messages;

Type
   TProcessingThread = class(TThread)
       private
           Msg : TMsg;
       protected
           procedure Execute; override;
           procedure processMessages;           
       public
           msgHandle : HWND;
           host : pointer;
           stop : boolean;
           synchronized: boolean;
   end;

implementation
uses unSMSClient;

procedure TProcessingThread.processMessages;
Begin
    TranslateMessage(Msg);
    DispatchMessage(Msg);
End;

procedure TProcessingThread.Execute;
Begin
    msgHandle := AllocateHwnd(TSMSClient(host).wndProc);
    stop := false;
    while (not stop) do begin
        if GetMessage(Msg,msgHandle, 0, 0) then begin
           if (Msg.message <> WM_OZ_STOP) then begin
              if (Msg.message <> WM_DO_LOGIN) then begin
                 if synchronized then
                 synchronize(processMessages)
                 else
                 processMessages;
              end else begin
                 processMessages;
              end;
           end;
        end;
    end;
    DeallocateHWnd(msgHandle);
End;

end.
