unit unSMSMessage;

interface
uses SysUtils;

Type

   TSMSMessage = class(TObject)
      messageID : string;
      sender : widestring;
      receiver : widestring;
      messagedata : widestring;
      messagetype : string;
      sentdate : string;
      receiveddate : string;
      serviceprovider : string;
      errorcode : integer;
      errormessage : widestring;

      constructor create;
      function toString : widestring;
      function formatDate(dat : TDateTime) : string;
   end;

implementation

function randomStringL(len : integer):string;
var
  s : string;
  x : integer;
Begin
  for x := 1 to len do begin
     s := s+chr(ord('A')+random(26));
  end;
  Result := s;
End;

constructor TSMSMessage.create;
Begin
   messageID := randomStringL(8);
   messagetype := 'SMS:TEXT';
   sentdate := formatDate(now);
End;

function TSMSMessage.formatDate(dat : TDateTime) : string;
Begin
   Result := FormatDateTime('yyyy-mm-dd hh:nn:ss',dat);
End;

Function TSMSMessage.toString : widestring;
Begin
    Result :=
    'ID: '+messageID+
    ' From: '+sender+
    ' To: '+receiver+
    ' Sent time: '+sentdate+
    ' Received time: '+receiveddate+
    ' Message type: '+messagetype+
    ' Message data: '+messagedata;
End;

end.
